Package io.vertx.reactivex.grpc.common

## Class GrpcWriteStream<T>

- java.lang.Object
- - io.vertx.reactivex.grpc.common.GrpcWriteStream<T>

- All Implemented Interfaces:
    `io.vertx.lang.rx.RxDelegate`, `StreamBase`, `WriteStream<T>`
  Direct Known Subclasses:
    `GrpcClientRequest`, `GrpcServerResponse`

      public class GrpcWriteStream<T>
      extends Object
      implements io.vertx.lang.rx.RxDelegate, WriteStream<T>

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static io.vertx.lang.rx.TypeArg<GrpcWriteStream>` | `__TYPE_ARG` |
    `io.vertx.lang.rx.TypeArg<T>` | `__typeArg_0` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `GrpcWriteStream​(GrpcWriteStream delegate)` |
    `GrpcWriteStream​(Object delegate, io.vertx.lang.rx.TypeArg<T> typeArg_0)` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `cancel()` | Cancel the stream.
    `GrpcWriteStream<T>` | `drainHandler​(Handler<Void> handler)` | Set a drain handler on the stream.
    `GrpcWriteStream<T>` | `encoding​(String encoding)` | Set the stream encoding, e.g.
    `Future<Void>` | `end()` | Ends the stream.
    `Future<Void>` | `end​(T data)` | Same as `WriteStream.end()` but writes some data to the stream before ending.
    `Future<Void>` | `endMessage​(GrpcMessage message)` | End the stream with an encoded gRPC message.
    `boolean` | `equals​(Object o)` |
    `GrpcWriteStream<T>` | `exceptionHandler​(Handler<Throwable> handler)` | Set an exception handler on the write stream.
    `GrpcWriteStream<T>` | `format​(WireFormat format)` | Set the stream format, e.g.
    `GrpcWriteStream` | `getDelegate()` |
    `int` | `hashCode()` |
    `MultiMap` | `headers()` |
    `static <T> GrpcWriteStream<T>` | `newInstance​(GrpcWriteStream arg)` |
    `static <T> GrpcWriteStream<T>` | `newInstance​(GrpcWriteStream arg, io.vertx.lang.rx.TypeArg<T> __typeArg_T)` |
    `Completable` | `rxEnd()` | Ends the stream.
    `Completable` | `rxEnd​(T data)` | Same as `WriteStream.end()` but writes some data to the stream before ending.
    `Completable` | `rxEndMessage​(GrpcMessage message)` | End the stream with an encoded gRPC message.
    `Completable` | `rxWrite​(T data)` | Write some data to the stream.
    `Completable` | `rxWriteMessage​(GrpcMessage message)` | Write an encoded gRPC message.
    `GrpcWriteStream<T>` | `setWriteQueueMaxSize​(int i)` | Set the maximum size of the write queue to `maxSize`.
    `WriteStreamObserver<T>` | `toObserver()` |
    `String` | `toString()` |
    `WriteStreamSubscriber<T>` | `toSubscriber()` |
    `Future<Void>` | `write​(T data)` | Write some data to the stream.
    `Future<Void>` | `writeMessage​(GrpcMessage message)` | Write an encoded gRPC message.
    `boolean` | `writeQueueFull()` | This will return `true` if there are more bytes in the write queue than the value set using `setWriteQueueMaxSize(int)`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### __TYPE_ARG

          public static final io.vertx.lang.rx.TypeArg<GrpcWriteStream> __TYPE_ARG

    - #### __typeArg_0

          public final io.vertx.lang.rx.TypeArg<T> __typeArg_0

  - ### Constructor Detail

    - #### GrpcWriteStream

          public GrpcWriteStream​(GrpcWriteStream delegate)

    - #### GrpcWriteStream

          public GrpcWriteStream​(Object delegate,
                                 io.vertx.lang.rx.TypeArg<T> typeArg_0)

  - ### Method Detail

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### equals

          public boolean equals​(Object o)

      Overrides:
        `equals` in class `Object`

    - #### hashCode

          public int hashCode()

      Overrides:
        `hashCode` in class `Object`

    - #### getDelegate

          public GrpcWriteStream getDelegate()

      Specified by:
        `getDelegate` in interface `io.vertx.lang.rx.RxDelegate`
      Specified by:
        `getDelegate` in interface `StreamBase`
      Specified by:
        `getDelegate` in interface `WriteStream<T>`

    - #### toObserver

          public WriteStreamObserver<T> toObserver()

      Specified by:
        `toObserver` in interface `WriteStream<T>`

    - #### toSubscriber

          public WriteStreamSubscriber<T> toSubscriber()

      Specified by:
        `toSubscriber` in interface `WriteStream<T>`

    - #### write

          public Future<Void> write​(T data)

      Write some data to the stream.

      The data is usually put on an internal write queue, and the write actually happens asynchronously. To avoid running out of memory by putting too much on the write queue, check the `WriteStream.writeQueueFull()` method before writing. This is done automatically if using a .

      When the `data` is moved from the queue to the actual medium, the returned will be completed with the write result, e.g the future is succeeded when a server HTTP response buffer is written to the socket and failed if the remote client has closed the socket while the data was still pending for write.

      Specified by:
        `write` in interface `WriteStream<T>`
      Parameters:
        `data` - the data to write
      Returns:
        a future completed with the write result

    - #### rxWrite

          public Completable rxWrite​(T data)

      Write some data to the stream.

      The data is usually put on an internal write queue, and the write actually happens asynchronously. To avoid running out of memory by putting too much on the write queue, check the `WriteStream.writeQueueFull()` method before writing. This is done automatically if using a .

      When the `data` is moved from the queue to the actual medium, the returned will be completed with the write result, e.g the future is succeeded when a server HTTP response buffer is written to the socket and failed if the remote client has closed the socket while the data was still pending for write.

      Specified by:
        `rxWrite` in interface `WriteStream<T>`
      Parameters:
        `data` - the data to write
      Returns:
        a future completed with the write result

    - #### end

          public Future<Void> end()

      Ends the stream.

      Once the stream has ended, it cannot be used any more.

      Specified by:
        `end` in interface `WriteStream<T>`
      Returns:
        a future completed with the result

    - #### rxEnd

          public Completable rxEnd()

      Ends the stream.

      Once the stream has ended, it cannot be used any more.

      Specified by:
        `rxEnd` in interface `WriteStream<T>`
      Returns:
        a future completed with the result

    - #### end

          public Future<Void> end​(T data)

      Same as `WriteStream.end()` but writes some data to the stream before ending.
      Specified by:
        `end` in interface `WriteStream<T>`
      Parameters:
        `data` - the data to write
      Returns:
        a future completed with the result

    - #### rxEnd

          public Completable rxEnd​(T data)

      Same as `WriteStream.end()` but writes some data to the stream before ending.
      Specified by:
        `rxEnd` in interface `WriteStream<T>`
      Parameters:
        `data` - the data to write
      Returns:
        a future completed with the result

    - #### writeQueueFull

          public boolean writeQueueFull()

      This will return `true` if there are more bytes in the write queue than the value set using `setWriteQueueMaxSize(int)`
      Specified by:
        `writeQueueFull` in interface `WriteStream<T>`
      Returns:
        `true` if write queue is full

    - #### headers

          public MultiMap headers()

      Returns:
        the to reader metadata headers

    - #### encoding

          public GrpcWriteStream<T> encoding​(String encoding)

      Set the stream encoding, e.g. `identity` or `gzip`,

      - The encoding must be set before sending any message, otherwise `identity` will be used.
      - The encoding should also match the opposite endpoint expectations.
      Parameters:
        `encoding` - the target message encoding
      Returns:
        a reference to this, so the API can be used fluently

    - #### format

          public GrpcWriteStream<T> format​(WireFormat format)

      Set the stream format, e.g. `proto` or `json`. It must be called before sending any message, otherwise `proto` will be used.
      Parameters:
        `format` - the message format
      Returns:
        a reference to this, so the API can be used fluently

    - #### exceptionHandler

          public GrpcWriteStream<T> exceptionHandler​(Handler<Throwable> handler)

      Description copied from interface: `WriteStream`
      Set an exception handler on the write stream.
      Specified by:
        `exceptionHandler` in interface `StreamBase`
      Specified by:
        `exceptionHandler` in interface `WriteStream<T>`
      Parameters:
        `handler` - the exception handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### setWriteQueueMaxSize

          public GrpcWriteStream<T> setWriteQueueMaxSize​(int i)

      Description copied from interface: `WriteStream`
      Set the maximum size of the write queue to `maxSize`. You will still be able to write to the stream even if there is more than `maxSize` items in the write queue. This is used as an indicator by classes such as `Pipe` to provide flow control.

      The value is defined by the implementation of the stream, e.g in bytes for a `NetSocket`, etc...
      Specified by:
        `setWriteQueueMaxSize` in interface `WriteStream<T>`
      Parameters:
        `i` - the max size of the write stream
      Returns:
        a reference to this, so the API can be used fluently

    - #### drainHandler

          public GrpcWriteStream<T> drainHandler​(Handler<Void> handler)

      Description copied from interface: `WriteStream`
      Set a drain handler on the stream. If the write queue is full, then the handler will be called when the write queue is ready to accept buffers again. See `Pipe` for an example of this being used.

      The stream implementation defines when the drain handler, for example it could be when the queue size has been reduced to `maxSize / 2`.

      Specified by:
        `drainHandler` in interface `WriteStream<T>`
      Parameters:
        `handler` - the handler
      Returns:
        a reference to this, so the API can be used fluently

    - #### writeMessage

          public Future<Void> writeMessage​(GrpcMessage message)

      Write an encoded gRPC message.
      Parameters:
        `message` - the message
      Returns:
        a future completed with the result

    - #### rxWriteMessage

          public Completable rxWriteMessage​(GrpcMessage message)

      Write an encoded gRPC message.
      Parameters:
        `message` - the message
      Returns:
        a future completed with the result

    - #### endMessage

          public Future<Void> endMessage​(GrpcMessage message)

      End the stream with an encoded gRPC message.
      Parameters:
        `message` - the message
      Returns:
        a future completed with the result

    - #### rxEndMessage

          public Completable rxEndMessage​(GrpcMessage message)

      End the stream with an encoded gRPC message.
      Parameters:
        `message` - the message
      Returns:
        a future completed with the result

    - #### cancel

          public void cancel()

      Cancel the stream.

    - #### newInstance

          public static <T> GrpcWriteStream<T> newInstance​(GrpcWriteStream arg)

    - #### newInstance

          public static <T> GrpcWriteStream<T> newInstance​(GrpcWriteStream arg,
                                                           io.vertx.lang.rx.TypeArg<T> __typeArg_T)